print $CLIENT_SOCKET "This is a sample test method.\n";

print $CLIENT_SOCKET "\n-- Printing raw contents of the args array : --\n";
print $CLIENT_SOCKET "@_", "\n";

my %args = (@_);

print $CLIENT_SOCKET "\n-- Printing method arguments (key: value) : --\n";
my @tmp_keys = keys(%args);
foreach $some_key (@tmp_keys)
{
  print $CLIENT_SOCKET "$some_key: $args{$some_key}\n";
}
print $CLIENT_SOCKET "\n";

if ( exists($args{"this"}) )
{
   my $obj_name = Kludge_pl::get_object_name($args{"this"});
   print $CLIENT_SOCKET "this->name == \"$obj_name\"\n";
}
else
{
   print $CLIENT_SOCKET "*this* undefined - this method was called statically.\n";
}

print $CLIENT_SOCKET "\n-- Testing some more XSUBs... -- \n";

my $tmp_obj_path = "Root_Instance_Class/Contents";
my $tmp_obj_ptr = Kludge_pl::Path2Ptr($tmp_obj_path,0);
my $tmp_obj_type = Kludge_pl::get_object_type($tmp_obj_ptr);
print $CLIENT_SOCKET "The path $tmp_obj_path resolves to pointer $tmp_obj_ptr\n";
print $CLIENT_SOCKET "This object is of type: $tmp_obj_type\n";
print $CLIENT_SOCKET "--\n";

my $tmp_obj_path = "./CLASS/Foo";
my $tmp_obj_ptr = Kludge_pl::Path2Ptr($tmp_obj_path, $args{"this"});
my $tmp_obj_type = Kludge_pl::get_object_type($tmp_obj_ptr);
print $CLIENT_SOCKET "The path $tmp_obj_path resolves to pointer $tmp_obj_ptr\n";
print $CLIENT_SOCKET "This object is of type: $tmp_obj_type\n";
print $CLIENT_SOCKET "--\n";

my $tmp_class_ptr = Kludge_pl::resolve_content_name($args{"this"}, "CLASS", 0);
print $CLIENT_SOCKET "The content name CLASS resolves to pointer $tmp_class_ptr\n";
print $CLIENT_SOCKET "The name of the resolved object is ", Kludge_pl::get_object_name($tmp_class_ptr), "\n";
my $tmp_obj_ptr = Kludge_pl::resolve_content_name($tmp_class_ptr, "Foo", 1);
print $CLIENT_SOCKET "In that object, content 'Foo' (own only) resolves to pointer $tmp_obj_ptr\n";
my $tmp_obj_ptr = Kludge_pl::resolve_content_name($tmp_class_ptr, "Foo", 0);
print $CLIENT_SOCKET "In that object, content 'Foo' (own+inherited) resolves to pointer $tmp_obj_ptr\n";
print $CLIENT_SOCKET "\n";

Kludge_pl::flush_file($CLIENT_SOCKET);

