#include "kludge_mysql.h"
#include <fstream>    // provides cout


string mysql_hostname = "localhost";
string mysql_username = "kludge";
string mysql_password = "";
string mysql_db_name = "kludge";
unsigned int mysql_remoteport = 0;

MYSQL *kludge_mysql_init()
{

   MYSQL *conn = NULL;

   conn=mysql_init(NULL);
   conn = mysql_real_connect(
                conn,
                mysql_hostname.c_str(),
                mysql_username.c_str(),
                mysql_password.c_str(),
                mysql_db_name.c_str(),
                mysql_remoteport,
                NULL,  /*socket default*/
                0);  /*flag*/

   if (conn == NULL) {
       cout << 
          "DB connection failed :(\n";
       exit(1);
       return(NULL);
   }
   else {
       cout <<
          "DB connection succeeded :)\n";
       return(conn);
   }
}



MYSQL_RES *kludge_mysql_query(const char *qry_string, MYSQL *conn)
{
 MYSQL_RES *qry_result = NULL;
 int qry_err_code;

   cout << "Query:\n " << qry_string << endl;

   qry_err_code = mysql_real_query(conn, qry_string, strlen(qry_string));
   if (qry_err_code == 0)
   {
      cout <<
         "DB query succeeded :)\n";
      
      qry_result = mysql_store_result(conn);
      if (qry_result == NULL)
      {
         cout << 
            "DB query result retrieval failed :(\n";
      }
      else
      {
         cout <<
            "DB query result retrieved :)\n";
      }
   }
   else
   {
      cout <<
         "DB query failed :(\n";
   }
   
   return(qry_result);
}



int kludge_mysql_cmd(const char *qry_string, MYSQL *conn)
{
 int result = 0;
 
   cout << "Command:\n " << qry_string << endl;

   result = mysql_real_query(conn, qry_string, strlen(qry_string));
   if (result == 0)
   {
      cout <<
         "DB command succeeded :)\n";
   }
   else
   {
      cout << 
         "DB command failed :(\n";
   }

   return(result);
}
